(game-module "wreckreation"
    (title "Wreckreation")
    (blurb "Fantasy genre; lots of special interactions. By Eric McDonald")
    (instructions "Wipe out the other sides.")
    (base-game true)
    (version "0.52 Devel")
    (variants
	("Arena Size" world-size 
	    "Width and height of arena in cells."
	    (200 200 7800)
	)
	("Mapped World" world-seen
	    "World terrain and independent units are known at start of game."
	    false
	    (true
		(add u* already-seen-independent 100%)
	    )
	)
	("Omniscience" see-all
	    "Everything is seen all the time."
	    false
	)
	("Sequential Play" sequential 
"Each side plays its turn separately, as opposed to all sides at once."
	    false
	)
	("Wimp Mode" docile-indepside
	    "Independent side is a drooling imbecile and does not do anything."
	    false
	    (true
		(set indepside-has-ai false)
		(set indepside-can-build false)
	    )
	)
	("Isles of War" mostly-water
	    "World is mostly oceanic, dotted with large islands."
	    false
	    (true
		(set alt-blob-density 30)
		(set wet-blob-density 2000)
		(set alt-blob-size 100)
		(set wet-blob-size 25)
		(undefine SEA_LAND_PERCENTILE)
		(undefine SEA_MAX_PERCENTILE)
		(undefine ALT_PERCENTILE_GAP)
		(undefine ALT1_MIN_PERCENTILE)
		(undefine ALT2_MIN_PERCENTILE)
		(undefine ALT3_MIN_PERCENTILE)
		(undefine ALT1_MAX_PERCENTILE)
		(undefine ALT2_MAX_PERCENTILE)
		(undefine ALT3_MAX_PERCENTILE)
		(define SEA_LAND_PERCENTILE 90%)
		(define SEA_MAX_PERCENTILE (- SEA_LAND_PERCENTILE 1))
		(define ALT_PERCENTILE_GAP (- 100% SEA_LAND_PERCENTILE))
		(define ALT1_MIN_PERCENTILE SEA_LAND_PERCENTILE)
		(define ALT2_MIN_PERCENTILE 
		    (+ SEA_LAND_PERCENTILE (/ (* ALT_PERCENTILE_GAP 50) 100))
		)
		(define ALT3_MIN_PERCENTILE 
		    (+ SEA_LAND_PERCENTILE (/ (* ALT_PERCENTILE_GAP 75) 100))
		)
		(define ALT1_MAX_PERCENTILE (- ALT2_MIN_PERCENTILE 1))
		(define ALT2_MAX_PERCENTILE (- ALT3_MIN_PERCENTILE 1))
		(define ALT3_MAX_PERCENTILE 100%)
		(add ocean alt-percentile-min 0%)
		(add (lake salt-marsh jungle forest tundra desert steppe green) 
		     alt-percentile-min ALT1_MIN_PERCENTILE
		)
		(add (append swamp hill-t*) alt-percentile-min 
		     ALT2_MIN_PERCENTILE
		)
		(add (append mountain-t* glacier) alt-percentile-min 
		     ALT3_MIN_PERCENTILE
		)
		(add ocean alt-percentile-max SEA_MAX_PERCENTILE)
		(add (salt-marsh jungle forest tundra desert steppe) 
		     alt-percentile-max ALT1_MAX_PERCENTILE
		)
		(add (append lake swamp hill-t* green) 
		     alt-percentile-max ALT2_MAX_PERCENTILE
		)
		(add (append mountain-t* glacier) alt-percentile-max 
		     ALT3_MAX_PERCENTILE
		)
		; By default, we play in a moderate climate.
		(add (jungle tundra) alt-percentile-min 100%)
		(add (jungle tundra) alt-percentile-max 100%)
	    )
	)
	("Land of Lakes" many-lakes
	    "No saltwater bodies. Many freshwater lakes."
	    false
	    (true
		(set alt-blob-density 100)
		(set wet-blob-density 2000)
		(set alt-blob-size 100)
		(set wet-blob-size 25)
		(undefine SEA_LAND_PERCENTILE)
		(undefine SEA_MAX_PERCENTILE)
		(undefine ALT_PERCENTILE_GAP)
		(undefine ALT1_MIN_PERCENTILE)
		(undefine ALT2_MIN_PERCENTILE)
		(undefine ALT3_MIN_PERCENTILE)
		(undefine ALT1_MAX_PERCENTILE)
		(undefine ALT2_MAX_PERCENTILE)
		(undefine ALT3_MAX_PERCENTILE)
		(define SEA_LAND_PERCENTILE 0%)
		(define SEA_MAX_PERCENTILE 100%)
		(define ALT_PERCENTILE_GAP (- 100% SEA_LAND_PERCENTILE))
		(define ALT1_MIN_PERCENTILE SEA_LAND_PERCENTILE)
		(define ALT2_MIN_PERCENTILE 
		    (+ SEA_LAND_PERCENTILE (/ (* ALT_PERCENTILE_GAP 50) 100))
		)
		(define ALT3_MIN_PERCENTILE 
		    (+ SEA_LAND_PERCENTILE (/ (* ALT_PERCENTILE_GAP 75) 100))
		)
		(define ALT1_MAX_PERCENTILE (- ALT2_MIN_PERCENTILE 1))
		(define ALT2_MAX_PERCENTILE (- ALT3_MIN_PERCENTILE 1))
		(define ALT3_MAX_PERCENTILE 100%)
		(add ocean alt-percentile-min 100%)
		(add (lake salt-marsh jungle forest tundra desert steppe green) 
		     alt-percentile-min ALT1_MIN_PERCENTILE
		)
		(add (append swamp hill-t*) alt-percentile-min 
		     ALT2_MIN_PERCENTILE
		)
		(add (append mountain-t* glacier) alt-percentile-min 
		     ALT3_MIN_PERCENTILE
		)
		(add ocean alt-percentile-max SEA_MAX_PERCENTILE)
		(add (salt-marsh jungle forest tundra desert steppe) 
		     alt-percentile-max ALT1_MAX_PERCENTILE
		)
		(add (append lake swamp hill-t* green) 
		     alt-percentile-max ALT2_MAX_PERCENTILE
		)
		(add (append mountain-t* glacier) alt-percentile-max 
		     ALT3_MAX_PERCENTILE
		)
		; By default, we play in a moderate climate.
		(add (jungle tundra) alt-percentile-min 100%)
		(add (jungle tundra) alt-percentile-max 100%)
		; Seed additional lakes and grow them.
		(table terrain-density add
		    (flat-t* lake 100)
		)
		(table adjacent-terrain-effect add
		    (lake (salt-marsh ocean sea-coast) non-terrain)
		    (soggy-t* lake lake)
		    (salt-marsh lake lake)
		    (salt-marsh salt-marsh lake)
		    (flat-t* lake lake)
		)
		(table adjacent-terrain-effect-chance add
		    (lake (salt-marsh ocean sea-coast) 0%)
		    (soggy-t* lake 50%)
		    (salt-marsh lake 100%)
		    (salt-marsh salt-marsh 100%)
		    (flat-t* lake 50%)
		)
		(table adjacent-terrain-effect-passes add
		    (soggy-t* lake 3)
		    (salt-marsh lake -1)
		    (flat-t* lake 4)
		)
		(undefine WET1_MIN_PERCENTILE)
		(undefine WET2_MIN_PERCENTILE)
		(undefine WET3_MIN_PERCENTILE)
		(undefine WET4_MIN_PERCENTILE)
		(undefine WET5_MIN_PERCENTILE)
		(undefine WET6_MIN_PERCENTILE)
		(undefine WET1_MAX_PERCENTILE)
		(undefine WET2_MAX_PERCENTILE)
		(undefine WET3_MAX_PERCENTILE)
		(undefine WET4_MAX_PERCENTILE)
		(undefine WET5_MAX_PERCENTILE)
		(undefine WET6_MAX_PERCENTILE)
		(define WET1_MIN_PERCENTILE 0%)
		(define WET2_MIN_PERCENTILE 10%)
		(define WET3_MIN_PERCENTILE 20%)
		(define WET4_MIN_PERCENTILE 50%)
		(define WET5_MIN_PERCENTILE 80%)
		(define WET6_MIN_PERCENTILE 85%)
		(define WET1_MAX_PERCENTILE (- WET2_MIN_PERCENTILE 1))
		(define WET2_MAX_PERCENTILE (- WET3_MIN_PERCENTILE 1))
		(define WET3_MAX_PERCENTILE (- WET4_MIN_PERCENTILE 1))
		(define WET4_MAX_PERCENTILE (- WET5_MIN_PERCENTILE 1))
		(define WET5_MAX_PERCENTILE (- WET6_MIN_PERCENTILE 1))
		(define WET6_MAX_PERCENTILE 100%)
		(add ocean wet-percentile-min 0%)
		(add lake wet-percentile-min WET6_MIN_PERCENTILE)
		(add (append soggy-t* glacier) wet-percentile-min 
		     WET5_MIN_PERCENTILE
		)
		(add woody-t* wet-percentile-min WET4_MIN_PERCENTILE)
		(add fertile-t* wet-percentile-min WET3_MIN_PERCENTILE)
		(add mtn-forest wet-percentile-min WET3_MIN_PERCENTILE)
		(add semi-arid-t* wet-percentile-min WET2_MIN_PERCENTILE)
		(add arid-t* wet-percentile-min WET1_MIN_PERCENTILE)
		(add (hill mountain) wet-percentile-min WET1_MIN_PERCENTILE)
		(add ocean wet-percentile-max 100%)
		(add (lake glacier) wet-percentile-max WET6_MAX_PERCENTILE)
		(add soggy-t* wet-percentile-max WET5_MAX_PERCENTILE)
		(add woody-t* wet-percentile-max WET4_MAX_PERCENTILE)
		(add fertile-t* wet-percentile-max WET3_MAX_PERCENTILE)
		(add semi-arid-t* wet-percentile-max WET2_MAX_PERCENTILE)
		(add arid-t* wet-percentile-max WET1_MAX_PERCENTILE)
		; Disable direct generation of bogs.
		(add bog wet-percentile-min 100%)
		(add bog wet-percentile-max 100%)
	    )
	)
	("Heat Wave" tropical-climate
	    "Tropical climate. Hot and steamy."
	    false
	    (true
		(undefine WET1_MIN_PERCENTILE)
		(undefine WET2_MIN_PERCENTILE)
		(undefine WET3_MIN_PERCENTILE)
		(undefine WET4_MIN_PERCENTILE)
		(undefine WET5_MIN_PERCENTILE)
		(undefine WET6_MIN_PERCENTILE)
		(undefine WET1_MAX_PERCENTILE)
		(undefine WET2_MAX_PERCENTILE)
		(undefine WET3_MAX_PERCENTILE)
		(undefine WET4_MAX_PERCENTILE)
		(undefine WET5_MAX_PERCENTILE)
		(undefine WET6_MAX_PERCENTILE)
		(define WET1_MIN_PERCENTILE 0%)
		(define WET2_MIN_PERCENTILE 5%)
		(define WET3_MIN_PERCENTILE 15%)
		(define WET4_MIN_PERCENTILE 50%)
		(define WET5_MIN_PERCENTILE 80%)
		(define WET6_MIN_PERCENTILE 97%)
		(define WET1_MAX_PERCENTILE (- WET2_MIN_PERCENTILE 1))
		(define WET2_MAX_PERCENTILE (- WET3_MIN_PERCENTILE 1))
		(define WET3_MAX_PERCENTILE (- WET4_MIN_PERCENTILE 1))
		(define WET4_MAX_PERCENTILE (- WET5_MIN_PERCENTILE 1))
		(define WET5_MAX_PERCENTILE (- WET6_MIN_PERCENTILE 1))
		(define WET6_MAX_PERCENTILE 100%)
		(add ocean wet-percentile-min 0%)
		(add lake wet-percentile-min WET6_MIN_PERCENTILE)
		(add (append soggy-t* glacier) wet-percentile-min 
		     WET5_MIN_PERCENTILE
		)
		(add woody-t* wet-percentile-min WET4_MIN_PERCENTILE)
		(add fertile-t* wet-percentile-min WET3_MIN_PERCENTILE)
		(add mtn-forest wet-percentile-min WET3_MIN_PERCENTILE)
		(add semi-arid-t* wet-percentile-min WET2_MIN_PERCENTILE)
		(add arid-t* wet-percentile-min WET1_MIN_PERCENTILE)
		(add (hill mountain) wet-percentile-min WET1_MIN_PERCENTILE)
		(add ocean wet-percentile-max 100%)
		(add (lake glacier) wet-percentile-max WET6_MAX_PERCENTILE)
		(add soggy-t* wet-percentile-max WET5_MAX_PERCENTILE)
		(add woody-t* wet-percentile-max WET4_MAX_PERCENTILE)
		(add fertile-t* wet-percentile-max WET3_MAX_PERCENTILE)
		(add semi-arid-t* wet-percentile-max WET2_MAX_PERCENTILE)
		(add arid-t* wet-percentile-max WET1_MAX_PERCENTILE)
		; Disable direct generation of bogs.
		(add bog wet-percentile-min 100%)
		(add bog wet-percentile-max 100%)
		; Now determine which terrains are in play.
		(add (lake swamp) alt-percentile-max ALT3_MAX_PERCENTILE)
		(add (glacier tundra forest) alt-percentile-min 100%)
		(add (glacier tundra forest) alt-percentile-max 100%)
		(add jungle alt-percentile-min ALT1_MIN_PERCENTILE)
		(add jungle alt-percentile-max ALT1_MAX_PERCENTILE)
	    )
	)
	("Iced Earth" iced-earth
	    "Boreal or subarctic climate. Dry and frigid."
	    false
	    (true
		; TODO: Alter latitude.
		; TODO: Make snow-covered images for places.
		(undefine WET1_MIN_PERCENTILE)
		(undefine WET2_MIN_PERCENTILE)
		(undefine WET3_MIN_PERCENTILE)
		(undefine WET4_MIN_PERCENTILE)
		(undefine WET5_MIN_PERCENTILE)
		(undefine WET6_MIN_PERCENTILE)
		(undefine WET1_MAX_PERCENTILE)
		(undefine WET2_MAX_PERCENTILE)
		(undefine WET3_MAX_PERCENTILE)
		(undefine WET4_MAX_PERCENTILE)
		(undefine WET5_MAX_PERCENTILE)
		(undefine WET6_MAX_PERCENTILE)
		(define WET1_MIN_PERCENTILE 0%)
		(define WET2_MIN_PERCENTILE 20%)
		(define WET3_MIN_PERCENTILE 40%)
		(define WET4_MIN_PERCENTILE 50%)
		(define WET5_MIN_PERCENTILE 85%)
		(define WET6_MIN_PERCENTILE 90%)
		(define WET1_MAX_PERCENTILE (- WET2_MIN_PERCENTILE 1))
		(define WET2_MAX_PERCENTILE (- WET3_MIN_PERCENTILE 1))
		(define WET3_MAX_PERCENTILE (- WET4_MIN_PERCENTILE 1))
		(define WET4_MAX_PERCENTILE (- WET5_MIN_PERCENTILE 1))
		(define WET5_MAX_PERCENTILE (- WET6_MIN_PERCENTILE 1))
		(define WET6_MAX_PERCENTILE 100%)
		(add ocean wet-percentile-min 0%)
		(add lake wet-percentile-min WET6_MIN_PERCENTILE)
		(add (append soggy-t* glacier) wet-percentile-min 
		     WET5_MIN_PERCENTILE
		)
		(add woody-t* wet-percentile-min WET4_MIN_PERCENTILE)
		(add fertile-t* wet-percentile-min WET3_MIN_PERCENTILE)
		(add mtn-forest wet-percentile-min WET3_MIN_PERCENTILE)
		(add semi-arid-t* wet-percentile-min WET2_MIN_PERCENTILE)
		(add arid-t* wet-percentile-min WET1_MIN_PERCENTILE)
		(add (hill mountain) wet-percentile-min WET1_MIN_PERCENTILE)
		(add ocean wet-percentile-max 100%)
		(add (lake glacier) wet-percentile-max WET6_MAX_PERCENTILE)
		(add soggy-t* wet-percentile-max WET5_MAX_PERCENTILE)
		(add woody-t* wet-percentile-max WET4_MAX_PERCENTILE)
		(add fertile-t* wet-percentile-max WET3_MAX_PERCENTILE)
		(add semi-arid-t* wet-percentile-max WET2_MAX_PERCENTILE)
		(add arid-t* wet-percentile-max WET1_MAX_PERCENTILE)
		; Determine which terrains are in play.
		(add bog name "frosty bog")
		(add ocean name "icy ocean")
		(add forest name "boreal forest")
		(add steppe name "frozen steppe")
		(add (salt-marsh desert) alt-percentile-min 100%)
		(add (salt-marsh desert) alt-percentile-max 100%)
		(add (bog tundra) alt-percentile-min ALT1_MIN_PERCENTILE)
		(add (bog tundra) alt-percentile-max ALT1_MAX_PERCENTILE)
		; Put some glaciated peaks in the ocean.
		(table terrain-density add
		    (ocean glacier 5)
		)
		; Override default deglaciation passes.
		; Let the glaciers grow instead.
		(table adjacent-terrain-effect add
		    (ocean glacier hill)
		    (sea-coast hill-t* (forest tundra))
		    ((hill mountain) glacier glacier)
		    (glacier (hill mountain) non-terrain)
		)
		(table adjacent-terrain-effect-chance add
		    (ocean glacier 95%)
		    ((hill mountain) glacier 25%)
		    (glacier (hill mountain) 0%)
		)
		(table adjacent-terrain-effect-passes add
		    (ocean glacier 4)
		    ((hill mountain) glacier 3)
		    (glacier (hill mountain) -1)
		)
	    )
	)
    )
)

;; General Definitions

(define TABLO -32768)
(define TABHI 32767)
(define PROPLO -32768)
(define PROPHI 32767)

(include "ng-weird")

;; Terrain

(include "wreckr-t")

(set alt-blob-density 8)
(set wet-blob-density 2000)

(set alt-blob-size 600)
(set wet-blob-size 25)

#| NOTE: The fractal-percentile terrain generator has 4000 bins, and starts 
    the blobbing process by lumping everything into the median bin, 2000. 
    From there, each blob provides either a negative or positive delta over 
    the number of cells given by the blob size. The delta is determined 
    by the blob height. During this process there is _no_ correlation to 
    terrain altitudes; those are handled later.
|#
(set alt-blob-height 500)
(set wet-blob-height 500)

(set alt-smoothing 4)
(set wet-smoothing 4)

(add t* alt-percentile-min 100%)
(add t* alt-percentile-max 100%)
(add t* wet-percentile-min 100%)
(add t* wet-percentile-max 100%)

(define SEA_LAND_PERCENTILE 20%)
(define SEA_MAX_PERCENTILE (- SEA_LAND_PERCENTILE 1))
(define ALT_PERCENTILE_GAP (- 100% SEA_LAND_PERCENTILE))
(define ALT1_MIN_PERCENTILE SEA_LAND_PERCENTILE)
(define ALT2_MIN_PERCENTILE 
    (+ SEA_LAND_PERCENTILE (/ (* ALT_PERCENTILE_GAP 50) 100))
)
(define ALT3_MIN_PERCENTILE 
    (+ SEA_LAND_PERCENTILE (/ (* ALT_PERCENTILE_GAP 75) 100))
)
(define ALT1_MAX_PERCENTILE (- ALT2_MIN_PERCENTILE 1))
(define ALT2_MAX_PERCENTILE (- ALT3_MIN_PERCENTILE 1))
(define ALT3_MAX_PERCENTILE 100%)
(add ocean alt-percentile-min 0%)
(add (lake salt-marsh jungle forest tundra desert steppe green) 
     alt-percentile-min ALT1_MIN_PERCENTILE
)
(add (append swamp hill-t*) alt-percentile-min ALT2_MIN_PERCENTILE)
(add (append mountain-t* glacier) alt-percentile-min ALT3_MIN_PERCENTILE)
(add ocean alt-percentile-max SEA_MAX_PERCENTILE)
(add (salt-marsh jungle forest tundra desert steppe) alt-percentile-max 
     ALT1_MAX_PERCENTILE
)
(add (append lake swamp hill-t* green) alt-percentile-max 
     ALT2_MAX_PERCENTILE
)
(add (append mountain-t* glacier) alt-percentile-max 
     ALT3_MAX_PERCENTILE
)
; By default, we play in a moderate climate.
(add (jungle tundra) alt-percentile-min 100%)
(add (jungle tundra) alt-percentile-max 100%)

(define WET1_MIN_PERCENTILE 0%)
(define WET2_MIN_PERCENTILE 15%)
(define WET3_MIN_PERCENTILE 35%)
(define WET4_MIN_PERCENTILE 70%)
(define WET5_MIN_PERCENTILE 90%)
(define WET6_MIN_PERCENTILE 97%)
(define WET1_MAX_PERCENTILE (- WET2_MIN_PERCENTILE 1))
(define WET2_MAX_PERCENTILE (- WET3_MIN_PERCENTILE 1))
(define WET3_MAX_PERCENTILE (- WET4_MIN_PERCENTILE 1))
(define WET4_MAX_PERCENTILE (- WET5_MIN_PERCENTILE 1))
(define WET5_MAX_PERCENTILE (- WET6_MIN_PERCENTILE 1))
(define WET6_MAX_PERCENTILE 100%)
(add ocean wet-percentile-min 0%)
(add lake wet-percentile-min WET6_MIN_PERCENTILE)
(add (append soggy-t* glacier) wet-percentile-min WET5_MIN_PERCENTILE)
(add woody-t* wet-percentile-min WET4_MIN_PERCENTILE)
(add fertile-t* wet-percentile-min WET3_MIN_PERCENTILE)
(add mtn-forest wet-percentile-min WET3_MIN_PERCENTILE)
(add semi-arid-t* wet-percentile-min WET2_MIN_PERCENTILE)
(add arid-t* wet-percentile-min WET1_MIN_PERCENTILE)
(add (hill mountain) wet-percentile-min WET1_MIN_PERCENTILE)
(add ocean wet-percentile-max 100%)
(add (lake glacier) wet-percentile-max WET6_MAX_PERCENTILE)
(add soggy-t* wet-percentile-max WET5_MAX_PERCENTILE)
(add woody-t* wet-percentile-max WET4_MAX_PERCENTILE)
(add fertile-t* wet-percentile-max WET3_MAX_PERCENTILE)
(add semi-arid-t* wet-percentile-max WET2_MAX_PERCENTILE)
(add arid-t* wet-percentile-max WET1_MAX_PERCENTILE)
; Disable direct generation of bogs.
(add bog wet-percentile-min 100%)
(add bog wet-percentile-max 100%)

; TODO: Specify height ranges and river chances.

(define TCAP_MAX 16)
(add t* capacity TCAP_MAX)

;; Materials

(material-type food (char "f"))
(material-type orc-food (char "f"))
; TODO: Add 'holy-water'.
; TODO: Add 'voodoo-dung'.
; TODO: Add 'faerie-fire'.
; TODO: Add 'blood'.

;; Units

; City Units
; CITY_U

; SMALL_CITY_U
(unit-type village (name "Village"))
(unit-type orc-holes-1 (name "Orc Holes"))
(unit-type catacombs-1 (name "Catacombs"))

; MEDIUM_CITY_U

; LARGE_CITY_U

(define small-city-u* (village orc-holes-1 catacombs-1))
(define medium-city-u* ())
(define large-city-u* ())
(define human-city-u* (village))
(define ugly-city-u* (orc-holes-1))
(define undead-city-u* (catacombs-1))
(define city-u* (append small-city-u* medium-city-u* large-city-u*))

(add small-city-u* vision-range 2)

; ABODE_U

(unit-type paladin-temple-1
    (name "Paladin Temple I")
)

(unit-type vampire-castle
    (name "Vampire Castle")
)

(define l1-abode-u* (paladin-temple-1))
(define l2-abode-u* ())
(define l3-abode-u* (vampire-castle))
(define human-abode-u* (paladin-temple-1))
(define ugly-abode-u* ())
(define undead-abode-u* (vampire-castle))
(define abode-u* (append l1-abode-u* l2-abode-u* l3-abode-u*))
(define facility-u* abode-u*)

(add l1-abode-u* hp-max 15)
(add l3-abode-u* hp-max 100)

(add l1-abode-u* vision-range 2)
(add l3-abode-u* vision-range 4)

; HUMAN_U

; HUMAN_WARRIOR_U

(unit-type human-fighter-1 (name "Novice Fighter"))
(unit-type human-paladin-1 (name "Novice Paladin"))

; HUMAN_MUSICIAN_U

; HUMAN_MAGE_U

; HUMAN_PRIEST_U

; HUMAN_MISC_U

(unit-type human-thralls (name "Humanoid Thralls"))

(define fighter-u* (human-fighter-1))
(define paladin-u* (human-paladin-1))
(define l1-human-warrior-u* (human-fighter-1 human-paladin-1))
(define human-warrior-u* (append fighter-u* paladin-u*))
(define human-musician-u* ())
(define human-mage-u* ())
(define human-priest-u* ())
(define human-misc-u* (human-thralls))
(define human-u* 
    (append 
     human-warrior-u* human-musician-u* human-mage-u* human-priest-u*
     human-misc-u*)
)

(add human-fighter-1 hp-max 10)
(add human-paladin-1 hp-max 15)
(add human-thralls hp-max 2)

(add human-paladin-1 destruction-result '((2 table) (1 vanish)))

(add fighter-u* vision-range 1)
; Paladins' sight is homed by their extrasensory abilities.
(add paladin-u* vision-range 2)
(add human-thralls vision-range 0)

; UGLY_U

; UGLY_WARRIOR_U

(unit-type goblin-fighter
    (name "Goblin")
)

; UGLY_MAGE_U

; UGLY_PRIEST_U

(unit-type snaga-shaman
    (name "Snaga Shaman")
)

; UGLY_MISC_U

(unit-type orc-thralls
    (name "Orcish Thralls")
)

; TODO: Define 'snaga', 'snaga-chieftain', 'uruk', and 'uruk-chieftain'.
; TODO: Define 'hobgoblin' and 'uruk-hai'.
; TODO: Define 'ogre', 'ogre-chieftain', 'ogre-lord', and 'ogre-mage'.

(define orc-warrior-u* (goblin-fighter))
(define orc-priest-u* (snaga-shaman))
(define orc-shaman-u* orc-priest-u*)
(define l1-ugly-u* (goblin-fighter))
(define l2-ugly-u* (snaga-shaman))
(define orc-misc-u* (orc-thralls))
(define goblin-u* (goblin-fighter))
(define orc-u* (append orc-warrior-u* orc-priest-u* orc-misc-u*))
(define ogre-u* ())
(define ugly-u* (append orc-u* ogre-u*))

; Orcs see farther at night.
; TODO: Add 'vision-night-effect'.
(add orc-u* vision-range 1)

(add snaga-shaman destruction-result '((4 table) (1 vanish)))

; UNDEAD_U

; ZOMBIE_U

(unit-type slow-zombie (name "Slow Zombie"))

; VAMPIRE_U

(unit-type nightwing (name "Nightwing"))

; TODO: Re-add Vampire Bats to game.
;	Lesser Vampire -> Vampire Bats (Small Flock)
;	Greater Vampire -> Vampire Bats (Large Flock)
;	Vampire Lord -> Vampire Bats (Massive Swarm)

(define zombie-u* (slow-zombie))
(define haunted-dead-u* ())
(define animated-dead-u* (append zombie-u* haunted-dead-u*))
(define wraith-u* ())
(define vampire-u* (nightwing))
(define damned-u* (append wraith-u* vampire-u*))
(define lich-u* ())
(define undead-u* (append animated-dead-u* damned-u* lich-u*))

; TODO: Define various zombies, such as Fast Zombie, Stinger Zombie, Shocker 
;	Zombie, and Flying Zombie.
; TODO: Define various helpers, such as Morbid Haunts and Soul Suckers.
; TODO: Define Skeleton Fighters and Skeleton Mages; they should be created 
;	by allowing Morbid Haunts to capture corpses, thus changing them into 
;	haunted skeletons, and then garrison themselves in the corpses. 
;	The wrecked type for these haunted skeletons should be Morbid 
;	Haunts, unless killed by anti-undead units, in which case they 
;	vanish.

; Zombies are not known for their vision.
(add zombie-u* vision-range 0)
; Vampires have an accute awareness of their surroundings.
(add vampire-u* vision-range 2)

; SPIRIT_U

(unit-type paladin-mentor-1 (name "Paladin Mentor I"))
(unit-type cackling-haunt (name "Cackling Haunt"))

; Aurae and fleeting presences.
(define ghost-u* (paladin-mentor-1))
; Haunting spirits.
(define haunt-u* (cackling-haunt))
; All spirits.
(define spirit-u* (append ghost-u* haunt-u*))

(add spirit-u* hp-max 5)

(add spirit-u* vision-range 2)

; MISC_U

(unit-type fresh-corpse
    (name "Fresh Corpse")
)

(unit-type decayed-corpse
    (name "Decayed Corpse")
)

(define corpse-u* (fresh-corpse decayed-corpse))

(add fresh-corpse hp-max 1)
(add decayed-corpse hp-max 5)

;; Unit Groupings
; GROUPS

; Places

(define paladin-temple-u* (paladin-temple-1))
(define human-place-u* (append human-city-u* human-abode-u*))

(define orc-holes-u* (orc-holes-1))
(define ugly-place-u* (append ugly-city-u* ugly-abode-u*))

(define catacombs-u* (catacombs-1))
(define undead-place-u* (append undead-city-u* undead-abode-u*))

(define place-u* (append city-u* abode-u*))

; Groups by Class

(define warrior-u* (append human-warrior-u* orc-warrior-u*))
(define archer-u* ())
(define musician-u* ())
(define mage-u* ())
(define priest-u* (append orc-priest-u*))

(define thralls-u* (human-thralls orc-thralls))

; Groups by Attack Type

(define melee-u* (append warrior-u*))

(define flat-missile-attack-u* ())
(define arc-missile-attack-u* ())
(define missile-attack-u* (append flat-missile-attack-u* arc-missile-attack-u*))

(define breath-attack-u* ())

(define spell-caster-u* (append mage-u* priest-u*))

(define speed1-firing-u* ())
(define speed2-firing-u* ())
(define speed3-firing-u* ())
(define speed4-firing-u* ())
(define range1-firing-u* ())
(define range2-firing-u* ())
(define range3-firing-u* ())
(define firing-u* (append missile-attack-u* breath-attack-u* spell-caster-u*))

; Groups by Special Abilities

(define l1-self-healer-u* (human-paladin-1 snaga-shaman nightwing))
(define l2-self-healer-u* ())
(define l3-self-healer-u* ())
(define l4-self-healer-u* ())
(define l5-self-healer-u* ())

(define l1-zombifier-u* (catacombs-1 nightwing))

; Groups by State of Existence

(define living-flesh-u* (append human-u* ugly-u*))

; Groups by Terrain of Mobility

(define land-u* (append human-u* ugly-u* slow-zombie))
(define sea-u* ())
(define air-u* (append vampire-u*))

; Groups by Mobility

(define mobile-u* (append living-flesh-u* undead-u*))

; Independent Units

(define indep-u* (village human-fighter-1))

; Create/Build/Repair Lists

(define VILLAGE_BUILDS (human-fighter-1))
(define ORC_HOLES_1_BUILDS (goblin-fighter snaga-shaman))
; TODO: Make Catacombs summon Morbid Haunts.
(define CATACOMBS_1_BUILDS (nightwing))

(define PALADIN_TEMPLE_1_BUILDS (human-paladin-1))

(define SLOW_ZOMBIE_BUILDS (catacombs-1))

(define THRALLS_BUILDS (orc-holes-1))

;; Unit Identifier Characters
; CHAR

; CHAR_GENERAL
(add fighter-u* char "f")
; TODO: (add archer-u* char "a")
; TODO: (add mage-u* char "m")
(add priest-u* char "p")
(add paladin-u* char "l")
; TODO: (add musician-u* char "b")
(add thralls-u* char ";")

; CHAR_CITY_U
(add small-city-u* char "1")
; TODO: (add medium-city-u* char "2")
; TODO: (add large-city-u* char "3")

; CHAR_ABODE_U
(add l1-abode-u* char "4")
; TODO: (add l2-abode-u* char "5")
(add l3-abode-u* char "6")

; CHAR_HUMAN_U

; CHAR_UGLY_U

; CHAR_UNDEAD_U
(add zombie-u* char "z")
(add vampire-u* char "V")

; CHAR_SPIRIT_U
(add ghost-u* char "G")
(add haunt-u* char "H")

; CHAR_MISC_U
(add corpse-u* char "!")

;; Unit Images
; IMAGE

; IMAGE_GENERAL
(add thralls-u* image-name "pg195")

; IMAGE_CITY_U
(add village image-name "ancient-village2")
(add orc-holes-u* image-name "ancient-burrow")
(add catacombs-u* image-name "spec-keepruin")

; IMAGE_ABODE_U
; TODO: Make each level of Paladin Temple be increasingly fancy ziggurat.
(add paladin-temple-u* image-name "ancient-ziggurat")
(add vampire-castle image-name "ancient-black-castle")

; IMAGE_HUMAN_U
(add human-fighter-1 image-name "ancient-swordman")
(add human-paladin-1 image-name "heroes-prince2")

; IMAGE_UGLY_U
(add goblin-u* image-name "monsters-orc3")
(add orc-shaman-u* image-name "monsters-grendel")

; IMAGE_UNDEAD_U
(add zombie-u* image-name "monsters-undead")
(add vampire-u* image-name "monsters-vampire")

; IMAGE_SPIRIT_U
(add paladin-mentor-1 image-name "spec-heart")
(add cackling-haunt image-name "monsters-big-sandman")

; IMAGE_MISC_U
; TODO: Make a more blackened version of the carcass image for Decayed Corpse.
(add corpse-u* image-name "carcass")

;; Unit Sizes
; SIZES

(table unit-size-in-terrain
    (u* t* 1)
    (place-u* t* TCAP_MAX)
)

(add l1-abode-u* capacity 2)
; TODO: (add l2-abode-u* capacity 4)
(add l3-abode-u* capacity 6)
; NOTE: Capacities >6 do not display well. The remedy for this would be a 
;  decent way to inspect occupants in some sort of magnification window.
(add small-city-u* capacity 4)
; TODO: (add medium-city-u* capacity 8)
; TODO: (add large-city-u* capacity 16)

;; Sides
; SIDES

(side 1 holy
    (name "The Paladinate") (adjective "holy") (class "holy")
)

(side 2 undead
    (name "The Undead") (adjective "nether") (class "undead")
)

(side 3 ugly
    (name "The Uglies") (adjective "nasty") (class "ugly")
)

; TODO: Add "The Druids" side with Fighters, Druids, and Ghosts.

;; Sides and Units

; SIDES_CITY_U

(add village possible-sides (or "independent" "holy"))
(add village start-with 3)

(add orc-holes-1 possible-sides "ugly")
(add orc-holes-1 start-with 5)

(add catacombs-1 possible-sides "undead")
(add catacombs-1 start-with 3)

; SIDES_ABODE_U

(add paladin-temple-1 possible-sides "holy")
(add paladin-temple-1 start-with 1)

(add vampire-castle possible-sides "undead")
(add vampire-castle start-with 1)

; SIDES_HUMAN_U

(add human-fighter-1 possible-sides (or "independent" "holy"))
(add human-fighter-1 start-with 10)

(add human-paladin-1 possible-sides "holy")
(add human-paladin-1 start-with 2)

(add human-thralls possible-sides "ugly")
(add human-thralls start-with 0)

; SIDES_UGLY_U

(add goblin-fighter possible-sides "ugly")
(add goblin-fighter start-with 20)

(add snaga-shaman possible-sides "ugly")
(add snaga-shaman start-with 2)

(add orc-thralls possible-sides "ugly")
(add orc-thralls start-with 3)

; SIDES_UNDEAD_U

(add slow-zombie possible-sides "undead")
(add slow-zombie start-with 10)

(add nightwing possible-sides "undead")
(add nightwing start-with 1)

; SIDES_SPIRIT_U

(add paladin-mentor-1 possible-sides "holy")

(add cackling-haunt possible-sides "ugly")

; SIDES_MISC_U

(add fresh-corpse possible-sides "independent")
(add decayed-corpse possible-sides "independent")

;; Special Attributes
; ATTRIB

; ATTRIB_GENERAL
(add u* advanced false)
(add u* acp-independent false)
(add u* colonizer false)
(add u* facility false)
(add u* ground false)
(add land-u* ground true)
(add u* naval false)
; TODO: (add sea-u* naval true)
(add u* air false)
(add air-u* air true)
(add u* minimal-sea-for-docks PROPHI)
(add u* ai-peace-garrison 0)
(add u* ai-war-garrison 0)

; ATTRIB_CITY_U
(add city-u* advanced true)
(add city-u* facility true)
(add small-city-u* ai-peace-garrison 1)
; TODO: (add medium-city-u* ai-peace-garrison 2)
; TODO: (add large-city-u* ai-peace-garrison 4)
(add small-city-u* ai-war-garrison 2)
; TODO: (add medium-city-u* ai-war-garrison 4)
; TODO: (add large-city-u* ai-war-garrison 8)

; ATTRIB_ABODE_U
(add abode-u* advanced true)
(add abode-u* facility true)

; ATTRIB_HUMAN_U

; ATTRIB_UGLY_U

; ATTRIB_UNDEAD_U

; ATTRIB_SPIRIT_U

; ATTRIB_MISC_U

;; Action Points
; ACP

; ACP_GENERAL
(define THRALLS_ACP 8)
(add u* acp-min 0)
(add u* acp-per-turn 1)
; Do not cap ACP with 'acp-max'.
(table night-adds-acp
    (u* t* 0)
)
(table night-multiplies-acp
    (u* t* 1.00)
)
(table occupant-adds-acp
    (u* u* 0)
)
(table occupant-multiplies-acp
    (u* u* 1.00)
)
(table acp-to-create
    (u* u* 0)
    (thralls-u* THRALLS_BUILDS THRALLS_ACP)
)
(table acp-to-build
    (u* u* 0)
    (thralls-u* THRALLS_BUILDS THRALLS_ACP)
)
(table acp-to-repair
    (u* u* 0)
    (thralls-u* THRALLS_BUILDS THRALLS_ACP)
)

; ACP_CITY_U
(table acp-to-create add
    (village VILLAGE_BUILDS 1)
    (orc-holes-1 ORC_HOLES_1_BUILDS 1)
    (catacombs-1 CATACOMBS_1_BUILDS 1)
)
(table acp-to-build add
    (village VILLAGE_BUILDS 1)
    (orc-holes-1 ORC_HOLES_1_BUILDS 1)
    (catacombs-1 CATACOMBS_1_BUILDS 1)
)
; Cities auto-repair any of the unit types that they build.

; ACP_ABODE_U
(table acp-to-create add
    (paladin-temple-1 PALADIN_TEMPLE_1_BUILDS 1)
)
(table acp-to-build add
    (paladin-temple-1 PALADIN_TEMPLE_1_BUILDS 1)
)
; Facilities auto-repair any of the unit types that they build.

; ACP_HUMAN_U
; Humans have average action rates.
(define HUMAN_ACP 10)
(add human-u* acp-per-turn HUMAN_ACP)
; Humans must sleep sometime. Give them 1/5 action at night.
(table night-multiplies-acp add
    (human-u* t* 0.20)
)

; ACP_UGLY_U
; Orcs are somewhat quick.
(define ORC_ACP 12)
(define ORC_DAY_ACP 6)
(add orc-u* acp-per-turn ORC_DAY_ACP)
; Orcs are sluggish and partly blinded when the sun is up. 
; Give them double action at night.
(table night-multiplies-acp add
    (orc-u* t* 2.00)
)

; ACP_UNDEAD_U

; ACP_ZOMBIE_U
; Zombie controllers don't much like daylight, so zombies move very slowly 
;  in the day as a result.
; Slow Zombies are ___slow.
(define SLOW_ZOMBIE_ACP 5)
(define ZOMBIE_DAY_ACP 3)
(add zombie-u* acp-per-turn ZOMBIE_DAY_ACP)
(table night-multiplies-acp add
    (slow-zombie t* 1.67)   ; 5/3 -> 5 ACP
)
(table acp-to-create add
    (slow-zombie SLOW_ZOMBIE_BUILDS SLOW_ZOMBIE_ACP)
)
(table acp-to-build add
    (slow-zombie SLOW_ZOMBIE_BUILDS SLOW_ZOMBIE_ACP)
)
(table acp-to-repair add
    (slow-zombie SLOW_ZOMBIE_BUILDS SLOW_ZOMBIE_ACP)
)

; ACP_VAMPIRE_U
; All the vampire types are very quick at night, but motionless in the day.
(define NIGHTWING_ACP 15)
(define VAMPIRE_DAY_ACP 0)
(add vampire-u* acp-per-turn VAMPIRE_DAY_ACP)
(table night-adds-acp add
    (nightwing t* NIGHTWING_ACP)
)

; ACP_SPIRIT_U
; Ghosts flit about very rapidly.
(add ghost-u* acp-per-turn 30)
; Haunts are not particularly quick.
(add haunt-u* acp-per-turn 10)

; ACP_MISC_U
(add corpse-u* acp-per-turn 0)

; ACP_GENERAL_EPILOG
(add thralls-u* acp-per-turn THRALLS_ACP)

;; Changing Type and Wrecking
; MORPH

; MORPH_GENERAL
(table can-change-type-to
    (u* u* false)
)
(add u* wrecked-type non-unit)
(add living-flesh-u* wrecked-type fresh-corpse)
(table wrecked-type-if-killed
    (u* u* non-unit)
    ; TODO: Small city units should become ruins when destroyed.
    ; Undead cities spread a plague to other cities.
    (small-city-u* undead-city-u* catacombs-1)
    ; TODO: (medium-city-u* undead-city-u* catacombs-2)
    ; TODO: (large-city-u* undead-city-u* necropolis)
    ; Undead cities can take over the bodies of the living who pass too near.
    (living-flesh-u* catacombs-1 slow-zombie)
    ; TODO: (living-flesh-u* catacombs-2 fast-zombie)
    ; TODO: (living-flesh-u* necropolis flying-zombie)
)
(table wrecked-type-if-starved
    (u* m* non-unit)
)
(table wrecked-type-if-attrited
    (u* t* non-unit)
)

; MORPH_CITY_U
(table wrecked-type-if-killed add
    (village orc-u* human-thralls)
)

; MORPH_HUMAN_U
(add paladin-u* wrecked-type non-unit)
(table wrecked-type-if-killed add
    (paladin-u* living-flesh-u* fresh-corpse)
    (human-thralls human-warrior-u* village)
)
(table wrecked-type-if-starved add
    (paladin-u* food fresh-corpse)
)
(table wrecked-type-if-attrited add
    (paladin-u* t* fresh-corpse)
    ; TODO: (paladin-3 t* paladin-mentor-1)
)

; MORPH_UGLY_U
(table wrecked-type-if-starved
    (snaga-shaman (food orc-food) cackling-haunt)
)

; MORPH_MISC_U
(table wrecked-type-if-killed add
    ; TODO: Change to zombie on capture rather than "death".
    (fresh-corpse l1-zombifier-u* slow-zombie)
)
(table wrecked-type-if-attrited add
    (fresh-corpse t* decayed-corpse)
    ; TODO: Add Decayed Corpse -> Skeleton.
)

(table can-change-type-to
)

(table acp-to-change-type
)

;; Movement

; MOVE_GENERAL
(add u* speed 100%)
(table mp-to-enter-terrain
    (land-u* liquid-t* TABHI)
)
(table mp-to-leave-terrain
    (land-u* liquid-t* TABHI)
)

; MOVE_CITY_U
(add city-u* speed 0%)

; MOVE_ABODE_U
(add abode-u* speed 0%)

; MOVE_HUMAN_U

; MOVE_UGLY_U

; MOVE_UNDEAD_U

; MOVE_SPIRIT_U
(table mp-to-enter-terrain add
#|
    (cackling-haunt t* TABHI)
    (cackling-haunt swamp 1)
|#
)
(table mp-to-leave-terrain add
#|
    (cackling-haunt t* TABHI)
    (cackling-haunt swamp 0)
|#
)

;; Combat

#|
; FIRE_GENERAL
; Firing units fire at different rates due to varying attack preparation 
;   times.
(add speed1-firing-u* acp-to-fire 1)
(add speed2-firing-u* acp-to-fire 2)
(add speed3-firing-u* acp-to-fire 3)
(add speed4-firing-u* acp-to-fire 4)
; No firing units can fire at an opponent in the same cell (range 0).
(add firing-u* range-min 1)
; Firing units can have different ranges.
(add range1-firing-u* range-max 1)
(add range2-firing-u* range-max 2)
(add range3-firing-u* range-max 3)
; All missile and breath attacks have an accuracy falloff after range 1.
; The accuracy of cast spells is not dependent on range, however.
(add firing-u* hit-falloff-range 1)
(add spell-caster-u* hit-falloff-range PROPHI)
; All flat trajectory missile attacks and breath attacks have a firing angle 
;  of 0 degrees.
; All arc trajectory missile attacks have a firing angle of 45 degrees.
; All cast spells can hit regardless of intervening elevations.
(add flat-missile-attack-u* fire-angle-max 0%)
(add arc-missile-attack-u* fire-angle-max 100%)
(add breath-attack-u* fire-angle-max 0%)
(add spell-caster-u* fire-angle-max 100%)
|#

(table acp-to-attack
    (u* u* 0)
    (human-fighter-1 u* 2)
    (human-paladin-1 u* 2)
    (goblin-fighter u* 2)
    (cackling-haunt u* 2)
    (slow-zombie u* 2)
    (nightwing u* 2)
;    (vampire-bats u* 2)
)
(add snaga-shaman acp-to-fire 1)
(add snaga-shaman range-min 1)
(add snaga-shaman range 3)
(add catacombs-1 acp-to-fire 1)
(add catacombs-1 range-min 0)
(add catacombs-1 range 3)
(table hit-at-max-range-effect
    (snaga-shaman u* 50%)
)

(table hit-chance
    (u* u* 0%)
    (u* place-u* 100%)
    (warrior-u* warrior-u* 50%)
    (warrior-u* paladin-mentor-1 25%)
    (warrior-u* thralls-u* 100%)
    (warrior-u* snaga-shaman 50%)
    (warrior-u* cackling-haunt 25%)
    (human-paladin-1 cackling-haunt 75%)
    (warrior-u* slow-zombie 75%)
    (human-paladin-1 slow-zombie 95%)
    (warrior-u* nightwing 25%)
    (human-paladin-1 nightwing 75%)
    (cackling-haunt u* 100%)
    (slow-zombie warrior-u* 25%)
    (slow-zombie thralls-u* 100%)
    (slow-zombie snaga-shaman 25%)
    (nightwing warrior-u* 75%)
    (nightwing paladin-mentor-1 50%)
    (nightwing thralls-u* 100%)
    (nightwing snaga-shaman 75%)
    (nightwing cackling-haunt 75%)
    (vampire-u* fresh-corpse 100%)
)
(table fire-hit-chance
    (u* u* 0%)
    (u* place-u* 100%)
    (snaga-shaman warrior-u* 75%)
    (snaga-shaman paladin-mentor-1 75%)
    (snaga-shaman cackling-haunt 25%)
    (snaga-shaman slow-zombie 95%)
    (snaga-shaman nightwing 75%)
    (catacombs-1 u* 50%)
    (catacombs-1 (paladin-temple-1 human-paladin-1 snaga-shaman) 0%)
)

(table damage
    (u* u* 0)
    ((human-fighter-1 human-paladin-1) place-u* 1)
    ((human-fighter-1 human-paladin-1) mobile-u* 2d4+2)
    (human-warrior-u* thralls-u* 1)
    (human-paladin-1 undead-u* 4d4+4)
    (goblin-fighter place-u* 2d4+2)
    (goblin-fighter mobile-u* 1d4+1)
    (slow-zombie place-u* 1)
    (slow-zombie mobile-u* 2d4+2)
    (slow-zombie (human-paladin-1 snaga-shaman) 1)
    (nightwing place-u* 4d4+4)
    (nightwing mobile-u* 4d4+4)
    (nightwing (human-paladin-1 snaga-shaman) 2d4+2) 
    (vampire-u* fresh-corpse 1)
)
(table fire-damage
    (u* u* 0)
    (snaga-shaman place-u* 2d4+2)
    (snaga-shaman mobile-u* 2d4+2)
    (snaga-shaman undead-u* 3d4+3)
    (catacombs-1 u* 10)
)

(table hp-min
    (u* paladin-mentor-1 5)
    (snaga-shaman paladin-mentor-1 0)
    (u* cackling-haunt 5)
    (human-paladin-1 cackling-haunt 0)
    (u* nightwing 5)
    ((human-paladin-1 snaga-shaman) nightwing 0)
    (u* fresh-corpse 1)
    (human-paladin-1 fresh-corpse 0)
    (vampire-u* fresh-corpse 0)
)

;; Capture, Scuttle, and Escape
; CAPE

; CAPE_GENERAL
(table capture-chance
    (u* u* 0%)
    (warrior-u* village 100%)
    (warrior-u* human-thralls 100%)
)
(table occupant-allows-capture-of
    (u* u* 100%)
    (warrior-u* place-u* 0%)
)
(table occupant-escape-chance
    (u* u* 0%)
)
(table changed-type-if-captured
    (village orc-warrior-u* human-thralls)
    ; TODO: Convert Human Thralls to Settlers instead of Village.
    (human-thralls human-warrior-u* village)
)

;; Unit Materials

; UMAT_GENERAL
(table unit-storage-x
    (u* m* 0)
)
(table base-production
    (u* m* 0)
)
(table base-consumption
    (u* m* 0)
)
(table in-length
    (u* m* 0)
)
(table out-length
    (u* m* 0)
)
(table unit-initial-supply
    (u* m* TABHI)
)

; UMAT_CITIES
(define VILLAGE_STORAGE_MULT (+ (- -5) (+)))	; Should come out to 5.
(define HUMAN_BURDEN_CAP (/ (+ 400) 5 2 (*) 1))	; Should come out to 40.
(table unit-storage-x add
    ; UMAT_SMALL_CITIES
    ; Village: 5 Fighters
;    (village food 200)
;    (village food (+ 50 50 75 25))
    (village food (* HUMAN_BURDEN_CAP VILLAGE_STORAGE_MULT))
;    (village food (/ (* HUMAN_BURDEN_CAP VILLAGE_STORAGE_MULT) 1))
;    (village (food orc-food) (+ 50 (150 50)))
;    (village (food orc-food) (+ (150 50) 50))
;    (village (food orc-food) (+ (50 50) (150 50)))
;    (village (food orc-food) (/ (1000 500) 5))
;    (village (food orc-food) (/ (1000 1000) (5 0.10)))
    ; Orc Holes: 8 Orcs
    (orc-holes-1 orc-food 192)
    ; Catacombs: No food.
    ; UMAT_MEDIUM_CITIES
    ; UMAT_LARGE_CITIES
)
(table base-production add
    ; UMAT_SMALL_CITIES
    ; Village: Capacity in 5 Turns; Farming and some Hunting
    (village food 40)
    ; Orc Holes: Capacity in 8 Turns; Hunting and Gathering
    (orc-holes-1 orc-food 24)
    ; Catacombs: No food.
    ; UMAT_MEDIUM_CITIES
    ; UMAT_LARGE_CITIES
)
(table base-consumption add
    ; UMAT_SMALL_CITIES
    ; Village: 10% Rats and Mice Loss
    (village food 4)
    ; Orc Holes: 50% Theft and Quarrelling Loss
    (orc-holes-1 orc-food 12)
    ; Catacombs: No food.
    ; UMAT_MEDIUM_CITIES
    ; UMAT_LARGE_CITIES
)
(table in-length add
    ; UMAT_SMALL_CITIES
    ; Village: Local food transport only.
    (village food 3)
    ; Orc Holes: No food transport.
    ; Catacombs: No food.
    ; UMAT_MEDIUM_CITIES
    ; UMAT_LARGE_CITIES
)
(table out-length add
    ; UMAT_SMALL_CITIES
    ; Village: Local food transport only.
    (village food 3)
    ; Orc Holes: No food transport. Orcs are greedy.
    ; Catacombs: No food.
    ; UMAT_MEDIUM_CITIES
    ; UMAT_LARGE_CITIES
)

; UMAT_ABODES
(table unit-storage-x add
    ; Paladin Temple I: 2 Paladins
    (paladin-temple-1 food 80)
    ; Vampire Castle: 1 Vampire
    ; TODO: 'blood' material
)
(table base-production add
    ; Paladin Temple I: No food production.
    ; Vampire Castle: No food production.
)
(table base-consumption add
    ; Paladin Temple I: No food loss due to cleanliness and wards.
    ; TODO: Plasma separation of 'blood' material.
)
(table in-length add
    ; Paladin Temple I: Extended local food transport.
    (paladin-temple-1 food 5)
    ; Vampire Castle: No food transport.
)
(table out-length add
    ; Paladin Temple I: Extended local food transport.
    (paladin-temple-1 food 5)
    ; Vampire Castle: No food transport.
)

; UMAT_HUMANS
(table unit-storage-x add
    ; UMAT_HUMAN_WARRIORS
    ; Fighter: 20 Days Journey
    (human-fighter-1 food 40)
    ; UMAT_HUMAN_SPECIAL_WARRIORS
    ; Paladin: 20 Days Journey
    (human-paladin-1 food 40)
    ; UMAT_HUMAN_MUSICIANS
    ; UMAT_HUMAN_MAGES
    ; UMAT_HUMAN_PRIESTS
    ; UMAT_HUMAN_MISC
    ; Thralls: 8 Days of Work
    (human-thralls food 16)
)
; No materials production.
(table base-consumption add
    ; UMAT_HUMAN_WARRIORS
    ; Fighter: 2 per Day
    (human-fighter-1 food 2)
    ; UMAT_HUMAN_SPECIAL_WARRIORS
    ; Paladin: 2 per Day
    (human-paladin-1 food 2)
    ; UMAT_HUMAN_MUSICIANS
    ; UMAT_HUMAN_MAGES
    ; UMAT_HUMAN_PRIESTS
    ; UMAT_HUMAN_MISC
    ; Thralls: 2 per Day
    (human-thralls food 2)
)
; Only direct food transport.

; UMAT_UGLIES
(table unit-storage-x add
    ; UMAT_UGLY_WARRIORS
    ; Orc: 12 Days Journey
    (goblin-fighter food 12)
    ; UMAT_UGLY_MAGES
    ; UMAT_UGLY_PRIESTS
    ; Snaga Shaman: 12 Days Journey
    (snaga-shaman food 24)
    ; UMAT_UGLY_MISC
    ; Thralls: 8 Days of Work
    (orc-thralls food 16)
)
; No materials production.
(table base-consumption add
    ; UMAT_UGLY_WARRIORS
    ; Orc: 1 per Day
    (goblin-fighter food 1)
    ; UMAT_UGLY_MAGES
    ; UMAT_UGLY_PRIESTS
    ; Snaga Shaman: 2 per Day
    (snaga-shaman food 2)
    ; UMAT_UGLY_THRALLS
    ; Thralls: 2 per Day
    (orc-thralls food 2)
)
; Only direct food transport.

;; Attrition and Starvation

(table hp-per-starve
    (living-flesh-u* food 10.00)
)
(table attrition
    (living-flesh-u* salt-marsh 4.00)
    (fresh-corpse t* 1.00)
    (decayed-corpse t* 1.00)
)

;; Construction and Repair
; BUILD

; BUILD_GENERAL
(define THRALLS_HP 4)
(add u* hp-max 1)
(add thralls-u* hp-max THRALLS_HP)
(add u* cp 1)
(add thralls-u* cp THRALLS_HP)
(table cp-on-creation
    (u* u* 0)
    (thralls-u* u* 1)
)
(table cp-per-build
    (u* u* 0)
    (thralls-u* u* 1)
)
(table auto-repair
    (u* u* 0.00)
)
(add u* cp-to-self-build PROPHI)
(add u* cp-per-self-build 1)
(table create-range
    (u* u* 0)
)
(table build-range
    (u* u* 0)
)
(table auto-repair-range
    (u* u* 0)
)
(add u* hp-recovery 0.00)
(add l1-self-healer-u* hp-recovery 1.00)
; TODO: (add l2-self-healer-u* hp-recovery 2.00)
; TODO: (add l3-self-healer-u* hp-recovery 4.00)
; TODO: (add l4-self-healer-u* hp-recovery 8.00)
; TODO: (add l5-self-healer-u* hp-recovery 16.00)
(table hp-to-repair
    (u* u* 1)
)
(table hp-per-repair
    (u* u* 1.00)
    (thralls-u* u* 1.00)
)

; BUILD_CITY_U
(define SMALL_CITY_HP 50)
(define MEDIUM_CITY_HP 250)
(define LARGE_CITY_HP 1250)
(add small-city-u* hp-max SMALL_CITY_HP)
; TODO: (add medium-city-u* hp-max MEDIUM_CITY_HP)
; TODO: (add large-city-u* hp-max LARGE_CITY_HP)
(add small-city-u* cp SMALL_CITY_HP)
; Medium and large cities cannot be directly built. They must grow and evolve.
(table cp-on-creation add
    (small-city-u* u* 1)
#| TODO
    (medium-city-u* u* 5)
    (large-city-u* u* 25)
|#
)
(table cp-per-build add
    (small-city-u* u* 1)
#| TODO
    (medium-city-u* u* 5)
    (large-city-u* u* 25)
|#
)
(table auto-repair add
    (village VILLAGE_BUILDS 1.00)
    (orc-holes-1 ORC_HOLES_1_BUILDS 1.00)
    (catacombs-1 CATACOMBS_1_BUILDS 1.00)
)
(add small-city-u* cp-to-self-build 1)
(table create-range add
    (city-u* u* 0)
    (small-city-u* facility-u* 1)
#| TODO
    (medium-city-u* facility-u* 2)
    (large-city-u* facility-u* 3)
|#
)
(table build-range add
    (city-u* u* 0)
    (small-city-u* facility-u* 1)
#| TODO
    (medium-city-u* facility-u* 2)
    (large-city-u* facility-u* 3)
|#
)
(table auto-repair-range add
    (city-u* u* 0)
    (small-city-u* facility-u* 1)
#| TODO
    (medium-city-u* facility-u* 2)
    (large-city-u* facility-u* 3)
|#
)
(add small-city-u* hp-recovery 1.00)
#| TODO
(add medium-city-u* hp-recovery 5.00)
(add large-city-u* hp-recovery 25.00)
|#

; BUILD_ABODE_U
(define L1_ABODE_HP 10)
(define L2_ABODE_HP 30)
(define L3_ABODE_HP 90)
(add l1-abode-u* hp-max L1_ABODE_HP)
; TODO: (add l2-abode-u* hp-max L2_ABODE_HP)
(add l3-abode-u* hp-max L3_ABODE_HP)
(add l1-abode-u* cp L1_ABODE_HP)
; Level 2 and 3 facilities cannot be directly built. They must grow and evolve.
(table cp-on-creation add
    (l1-abode-u* u* 1)
; TODO:    (l2-abode-u* u* 3)
    (l3-abode-u* u* 9)
)
(table cp-per-build add
    (l1-abode-u* u* 1)
; TODO:    (l2-abode-u* u* 3)
    (l3-abode-u* u* 9)
)
(table auto-repair add
    (paladin-temple-1 PALADIN_TEMPLE_1_BUILDS 1.00)
)
(add l1-abode-u* cp-to-self-build 1)
(table auto-repair-range add
    (abode-u* u* 0)
    ; TODO: Paladin Temples should auto-repair units in their ZOC.
)
(add l1-abode-u* hp-recovery 1.00)
; TODO: (add l2-abode-u* hp-recovery 3.00)
(add l3-abode-u* hp-recovery 9.00)

; BUILD_HUMAN_U
(define HUMAN_FIGHTER_1_HP 10)
(define HUMAN_PALADIN_1_HP 12)
(add human-fighter-1 hp-max HUMAN_FIGHTER_1_HP)
(add human-paladin-1 hp-max HUMAN_PALADIN_1_HP)
(add human-fighter-1 cp HUMAN_FIGHTER_1_HP)
(add human-paladin-1 cp HUMAN_PALADIN_1_HP)

; BUILD_UGLY_U
(define GOBLIN_FIGHTER_HP 6)
(define SNAGA_SHAMAN_HP 6)
(add goblin-fighter hp-max GOBLIN_FIGHTER_HP)
(add snaga-shaman hp-max SNAGA_SHAMAN_HP)
(add goblin-fighter cp GOBLIN_FIGHTER_HP)
(add snaga-shaman cp SNAGA_SHAMAN_HP)

; BUILD_UNDEAD_U
(define ZOMBIE_HP 15)
(define NIGHTWING_HP 12)
(add zombie-u* hp-max ZOMBIE_HP)
(add nightwing hp-max NIGHTWING_HP)
(add nightwing cp NIGHTWING_HP)
(table cp-on-creation add
    (zombie-u* u* 1)
)
(table cp-per-build add
    (zombie-u* u* 1)
)
(table hp-per-repair add
    (zombie-u* u* 1.00)
)

;; World and Playing Arena Setup

(world
    ; World Circumference in Cells
    ; 2 * Pi * 6000 km ~= 38000 km Circumference
    ; 38000 km / 5 km = 7800 cells Circumference
    (circumference 7800)
    ; Day and Night
    ;   Some creatures may be more active or have better vision at night, 
    ; whereas others may be more active or have better vision during the 
    ; day. Give each category an equal chance to perform at its best and 
    ; worst.
    (day-length 2)
    ; Lighting Coverage
    ; We use an exact partition between day and night, for now.
    (daylight-fraction 50%)
    (twilight-fraction 50%)
)

; 1000 km x 1000 km Default Area
; (Let world-size variant handle the dimensions.)
(area #| 200 200 |#
    ; Cell Width: 5 km
    ;   Elevation must be more sensitive than cell width, so we express 
    ; the width in terms of the more detailed elevation height units (meters).
    (cell-width 5000)
)

;; Game Setup

(set sides-min 2)
(set sides-wanted 3)
(set sides-max 3)

(scorekeeper (do last-side-wins))

(add place-u* namer "generic-names")
(add (human-paladin-1 nightwing) namer "generic-names")

(set indepside-has-ai true)
(set indepside-can-build true)

; Combat protection does not have an effect on capture protection in this game.
(set protection-resists-capture false)

(table independent-density
#|
    (village (plain steppe forest semi-desert) (200 150 150 100))
|#
    (village green 200)
)

(table favored-terrain
    (u* t* 0%)
    (u* green 100%)
#|
    ((village paladin-temple-1 human-fighter-1 human-paladin-1) green 100%)
    ((orc-holes-1 orc-thralls goblin-fighter snaga-shaman) mountain 100%)
    ((catacombs-1 slow-zombie) plain 100%)
    ((vampire-castle nightwing) mountain 100%)
|#
)

(set synthesis-methods '(
    make-fractal-percentile-terrain
    make-rivers
    make-countries
    make-independent-units
    make-initial-materials
    name-units-randomly
))
